#ifndef PROC_STAT_H
#define PROC_STAT_H

/*
 *  Copyright (C) 2001  Concurrent Computer Corporation
 *  This source is covered by the GNU LGPL Version 2.1
 *  Author: Jason Baietto (jason.baietto@ccur.com)
 */

#include <sys/types.h>

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  Enumeration of the current values seen in /proc/<id>/stat.
 *  Note that the uid has been substituted for the task field.
 */
#define PROC_STAT_UID              0
#define PROC_STAT_CMD              1
#define PROC_STAT_STATE            2
#define PROC_STAT_PPID             3
#define PROC_STAT_PGRP             4
#define PROC_STAT_SESSION          5
#define PROC_STAT_TTY              6
#define PROC_STAT_TTY_PGRP         7
#define PROC_STAT_FLAGS            8
#define PROC_STAT_MIN_FLT          9
#define PROC_STAT_CMIN_FLT         10
#define PROC_STAT_MAJ_FLT          11
#define PROC_STAT_CMAJ_FLT         12
#define PROC_STAT_UTIME            13
#define PROC_STAT_STIME            14
#define PROC_STAT_CUTIME           15
#define PROC_STAT_CSTIME           16
#define PROC_STAT_PRIORITY         17
#define PROC_STAT_NICE             18
#define PROC_STAT_UNUSED           19
#define PROC_STAT_IT_REAL          20
#define PROC_STAT_START_TIME       21
#define PROC_STAT_VMSIZE           22
#define PROC_STAT_MM_RSS           23
#define PROC_STAT_RLIMIT           24
#define PROC_STAT_MM_START_CODE    25
#define PROC_STAT_MM_END_CODE      26
#define PROC_STAT_MM_START_STACK   27
#define PROC_STAT_ESP              28
#define PROC_STAT_EIP              29
#define PROC_STAT_SIG_PENDING      30
#define PROC_STAT_SIG_BLOCKED      31
#define PROC_STAT_SIG_IGNORE       32
#define PROC_STAT_SIG_CATCH        33
#define PROC_STAT_WCHAN            34
#define PROC_STAT_NSWAP            35
#define PROC_STAT_CNSWAP           36
#define PROC_STAT_EXIT_SIGNAL      37
#define PROC_STAT_PROCESSOR        38
#define PROC_STAT_RT_PRIORITY      39
#define PROC_STAT_RT_POLICY        40
#define PROC_STAT_PID              100

#define PROC_STAT_SUCCESS          0
#define PROC_STAT_FAILURE          -1

extern int proc_stat(pid_t, int, void*);

#ifdef __cplusplus
  }
#endif

#endif /* PROC_STAT_H */
