#ifndef PROC_WALK_H
#define PROC_WALK_H

/*
 *  Copyright (C) 2001  Concurrent Computer Corporation
 *  This source is covered by the GNU LGPL Version 2.1
 *  Author: Jason Baietto (jason.baietto@ccur.com)
 *
 *  Use proc_walk to walk through all pids/tids on the system.
 *  Use thread_walk to walk through all tids of a given pid.
 */

#include <dirent.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct proc_walk_id pwid_t;
typedef struct thread_walk_id twid_t;

extern pwid_t* proc_walk_init(void);
extern int proc_walk_get_next_pid(pwid_t*);
extern int proc_walk_get_next_tid(pwid_t*);
extern int proc_walk_get_pid(pwid_t*);
extern void proc_walk_reset(pwid_t*);
extern void proc_walk_done(pwid_t*);

extern twid_t* thread_walk_init(pid_t);
extern int thread_walk_get_next_tid(twid_t*);
extern void thread_walk_reset(twid_t*);
extern void thread_walk_done(twid_t*);

#ifdef __cplusplus
  }
#endif

#endif /* PROC_WALK_H */
